import Cocoa

// code 3.17
var f1: Int -> Int
do {
  var captured = 10
  f1 = {(i1: Int) -> Int in
    return captured++ * i1
  }
} while false
f1(5)
f1(6)

// code 3.18
let calculatedString = {(count: Int) -> String in
  var paren = ("", "")
  func calc(i2: Int) -> String {
    return paren.0 + String(i2 * i2) + paren.1
  }
  var result = ""
  paren = ("[", "]")
  result += calc(count - 1)
  paren = ("{", "}")
  result += calc(count)
  return result
}
calculatedString(10)

// code 3.19
let ff_int = {(i:Int, f:(Int -> Int)) -> Int in
  return f(i)
}
let sq_int = {(i:Int) -> Int in
  return i * i
}
ff_int(5, sq_int)

// code 3.24
ff_int(5, {$0 * $0})
let sq_int3: Int -> Int = {$0 * $0}

// code 3.26, 3.27 (Swift 1.2でエラー)
func my_message(condition: Bool, message: @autoclosure () -> String) -> String {
  if condition {
    return message()
  } else {
    return "NO"
  }
}
func my_string() -> String {
  var str = "a"
  for _ in 1...10 {
    str += str
  }
  return str
}
var a = 0
my_message(a == 0, my_string())
a = 1
my_message(a == 0, my_string())

// code 3.29
let calculatedString_ = {(count: Int) -> String in
  var paren = ("", "")
  var calc: Int -> String
  do {
    let paren_ = paren
    calc = {(i2: Int) -> String in
      return paren_.0 + String(i2 * i2) + paren_.1
    }
  } while false
  var result = ""
  paren = ("[", "]")
  result += calc(count - 1)
  paren = ("{", "}")
  result += calc(count)
  return result
}
calculatedString_(10)
